diff -udNr xdvik//encodings.c pxdvik//encodings.c
--- xdvik//encodings.c	2009-11-10 19:28:49.000000000 +0900
+++ pxdvik//encodings.c	2010-07-25 14:56:37.638074508 +0900
@@ -69,10 +69,12 @@
 #if HAVE_ICONV_H
 # include <iconv.h>
 static iconv_t m_iconv_gb_ucs4 = (iconv_t)(-1);
+static iconv_t m_iconv_jis_ucs4 = (iconv_t)(-1);
 #endif /* HAVE_ICONV_H */
 
 #include <ctype.h>
 
+#include "ptexmap.h"
 #include "util.h"
 #include "encodings.h"
 #include "my-snprintf.h"
@@ -3021,9 +3023,68 @@
 	iconv_close(m_iconv_gb_ucs4);
 	m_iconv_gb_ucs4 = (iconv_t)(-1);
     }
+    if (m_iconv_jis_ucs4 != (iconv_t)(-1)) {
+	iconv_close(m_iconv_jis_ucs4);
+	m_iconv_jis_ucs4 = (iconv_t)(-1);
+    }
 #endif /* HAVE_ICONV_H */
 }
 
+#ifdef PTEX
+/* convert a JIS char to unicode (UCS-4) using iconv() */
+static uint32_t
+jis2unicode(wide_ubyte jis)
+{
+#if HAVE_ICONV_H
+    uint32_t u = 0;
+    unsigned char jis_seq[8] = { 
+	0x1b, 0x24, 0x42, /* JIS X 0208-1983 */
+	(unsigned char)(jis >> 8), (unsigned char)jis,
+	0x1b, 0x28, 0x42, /* ASCII */
+    };
+    unsigned char unicode[4];
+    size_t from = sizeof jis_seq;
+    size_t to = sizeof unicode;
+    static Boolean initialized = False;
+    char *from_ptr = (char *)jis_seq;
+    char *to_ptr = (char *)unicode;
+
+    if (m_iconv_jis_ucs4 == (iconv_t)(-1)) {
+	if (initialized)
+	    return 0;
+	initialized = True;
+	m_iconv_jis_ucs4 = iconv_open(
+#ifdef WORDS_BIGENDIAN
+				     "UCS-4BE",
+#else
+				     "UCS-4LE",
+#endif
+				     "ISO-2022-JP");
+	if (m_iconv_jis_ucs4 == (iconv_t)(-1)) {
+	    XDVI_ERROR((stderr, "jis2unicode: iconv_open() failed: %s", strerror(errno)));
+	    return 0;
+	}
+    }
+    if (iconv(m_iconv_jis_ucs4, (iconv_char_pptrT)&from_ptr, &from, &to_ptr, &to) == (size_t)(-1)) {
+	XDVI_ERROR((stderr, "jis2unicode: can't convert JIS to unicode: %s", strerror(errno)));
+	return 0;
+    }
+    memcpy(&u, unicode, sizeof unicode);
+    return u;
+#else /* HAVE_ICONV_H */
+    static Boolean warned = False;
+
+    if (!warned) {
+        popup_message(globals.widgets.top_level,
+                      MSG_WARN, NULL, "This version of xdvi has been compiled without iconv support - "
+                      "cannot convert Kanji character to UTF-8");
+        warned = True;
+    }
+    return 0;
+#endif /* HAVE_ICONV_H */
+}
+#endif /* PTEX */
+
 /* convert a CJK char to unicode (UCS-4) using iconv() */
 static uint32_t
 cjk2unicode(unsigned char *cjk)
@@ -3577,6 +3638,24 @@
     
     TRACE_FIND_VERBOSE((stderr, "guess_encoding: |%s|, char 0x%.4X", fontname, ch));
 
+#ifdef PTEX
+    if (iskanjifont(fontname)) {
+	struct ptexmap *map = getkanjifont(fontname);
+	switch (map->encoding) {
+	case ENC_JIS_H:
+	case ENC_JIS_V:
+	    TRACE_FIND_VERBOSE((stderr, "guess_encoding: Kanji fonts (JIS encoding)"));
+	    return jis2unicode(ch);
+	case ENC_UNICODE_H:
+	case ENC_UNICODE_V:
+	    TRACE_FIND_VERBOSE((stderr, "guess_encoding: Kanji fonts (Unicode encoding)"));
+	    return ch;
+	default:
+	    TRACE_FIND_VERBOSE((stderr, "guess_encoding: Kanji fonts (Unsupported encoding)"));
+	    return '?';
+	}
+    }
+#endif  /* PTEX */
     /* our encoding vectors only have size 256 */
     if (ch > 255) {
 	XDVI_WARNING((stderr, "guess_encoding: font index %lu too large", (unsigned long)ch));
diff -udNr xdvik//font-open.c pxdvik//font-open.c
--- xdvik//font-open.c	2008-07-02 00:42:36.000000000 +0900
+++ pxdvik//font-open.c	2010-07-25 14:56:37.638074508 +0900
@@ -27,6 +27,7 @@
 #include "xdvi-config.h"
 #include "xdvi.h"
 #include "dvi-draw.h"
+#include "ptexmap.h"
 #include "util.h"
 #include "events.h"
 #include "dvi-init.h"
@@ -289,7 +290,7 @@
 #endif
 	  Boolean use_t1lib)
 {
-    char *name;
+    char *name = NULL;
     kpse_glyph_file_type file_ret;
 #if DELAYED_MKTEXPK
     Boolean message_done = False;
@@ -303,15 +304,15 @@
     fontp->filename = NULL;
     *dpi_ret = fontp->fsize;
 
-    if (resource.omega) { /* for omega, first try 16-bit ovf's, then 8-bit vf's. */
-	name = kpse_find_ovf(fontp->fontname);
-	if (name == NULL)
-	    name = kpse_find_vf(fontp->fontname);
-    }
-    else {
-	name = kpse_find_vf(fontp->fontname);
-    }
-    
+#ifdef PTEX
+     /* for kanji, first try jfm's, then 8-bit vf's (not 16bit ovf's). */
+    if (iskanjifont(fontp->fontname)) name = kpse_find_tfm(fontp->fontname);
+    else
+#endif /* PTEX */
+     /* for omega, first try 16-bit ovf's, then 8-bit vf's. */
+    if (resource.omega) name = kpse_find_ovf(fontp->fontname);
+    if (name == NULL)   name = kpse_find_vf(fontp->fontname);
+
 #ifdef T1LIB
     if (resource.t1lib) {
 	*t1id = -1;
diff -udNr xdvik//fontconfig.c pxdvik//fontconfig.c
--- xdvik//fontconfig.c	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//fontconfig.c	2010-07-25 14:56:37.638074508 +0900
@@ -0,0 +1,92 @@
+#include "xdvi-config.h"
+#include "xdvi.h"
+#include <stdio.h>
+#include "util.h"
+#include "string-utils.h"
+
+#ifdef	PTEX
+#include "kpathsea/tex-file.h"
+
+#if	HAVE_FONTCONFIG
+#include <fontconfig/fontconfig.h>
+
+char *fc_match(char *name)
+{
+    FcFontSet   *fs;
+    FcPattern   *pat;
+    FcResult    result;
+    FcPattern   *match;
+    char        *ret = NULL;
+    static int inited = false;
+
+    if (!inited) {
+        if (FcInit() == 0) {
+            XDVI_WARNING((stderr, "fontconfig: Can't init library.\n"));
+            return NULL;
+        }
+        inited = true;
+    }
+
+    pat = FcNameParse((FcChar8 *)name);
+    FcConfigSubstitute(0, pat, FcMatchPattern);
+    FcDefaultSubstitute(pat);
+    fs = FcFontSetCreate();
+    match = FcFontMatch(0, pat, &result);
+    if (match != NULL) FcFontSetAdd(fs, match);
+    if (pat != NULL) FcPatternDestroy(pat);
+
+    if (fs != NULL) {
+        if (fs->nfont > 0) {
+            FcChar8   *file;
+            if (FcPatternGetString(fs->fonts[0], FC_FILE, 0, &file)
+                == FcResultMatch) {
+                ret = strdup(file);
+            }
+        }
+        FcFontSetDestroy(fs);
+    }
+    if (kpathsea_debug) {
+        fprintf(stderr, "fontconfig:fc_match(%s) => %s\n", name, ret);
+    }
+    return ret;
+}
+
+char *fc_convert(char *name) {
+    char *tmp, *s;
+
+    if (str_is_suffix(".otf", name, false)) return NULL;
+    if (str_is_suffix(".ttf", name, false)) return NULL;
+    if (str_is_suffix(".ttc", name, false)) return NULL;
+    tmp = strdup(name);
+    s = strstr(tmp, "-Light");   if (s != NULL) *s = '\0';
+    s = strstr(tmp, "-Medium");  if (s != NULL) *s = '\0';
+    s = strstr(tmp, "-Regular"); if (s != NULL) *s = '\0';
+    s = fc_match(tmp);
+    free(tmp);
+    return s;
+}
+#endif	/* HAVE_FONTCONFIG */
+
+
+const char *get_ptex_font_pathname(char *name)
+{
+    char *s = NULL;
+    FILE *fp;
+
+    if ((fp=XFOPEN(name, "r")) != NULL) {
+	fclose(fp);
+	s = name;
+    }
+
+    if (s == NULL) s = kpse_find_file(name, kpse_opentype_format, true);
+    if (s == NULL) s = kpse_find_file(name, kpse_truetype_format, true);
+    if (s == NULL) s = kpse_find_file(name, kpse_miscfonts_format, true);
+    if (s == NULL) s = kpse_find_file(name, kpse_program_text_format, true);
+#if	HAVE_FONTCONFIG
+    if (s == NULL) s = fc_convert(name);
+#endif	/* HAVE_FONTCONFIG */
+    if (s == NULL) s = name;
+    return s;
+}
+
+#endif	/* PTEX */
diff -udNr xdvik//fontconfig.h pxdvik//fontconfig.h
--- xdvik//fontconfig.h	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//fontconfig.h	2010-07-25 14:56:37.638074508 +0900
@@ -0,0 +1,6 @@
+
+#ifdef	PTEX
+
+char *get_ptex_font_pathname(char *name);
+
+#endif /* PTEX */
diff -udNr xdvik//ft2.c pxdvik//ft2.c
--- xdvik//ft2.c	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//ft2.c	2010-07-25 14:56:37.638074508 +0900
@@ -0,0 +1,249 @@
+#include "xdvi-config.h"
+#include "xdvi.h"
+#include <stdio.h>
+#include <stdlib.h>
+
+#ifdef	PTEX
+#include <ft2build.h>
+#include FT_FREETYPE_H
+#include FT_SYNTHESIS_H
+
+#include "kpathsea/tex-file.h"
+#include "ft2.h"
+#include "dvi-init.h"
+#include "util.h"
+#include "ptexmap.h"
+#include "ft2vert.h"
+#include "fontconfig.h"
+#include "jisx0208.h"
+
+static struct jisv_st {
+    int low, hi;
+} jisv[] = {
+    /* converted from CMap 'V' */
+    /* sed -e '/^</!d' -e 's|<\(....\)> <\(....\)>.*|  { 0x\1, 0x\2 },|' < V */
+    { 0x2122, 0x2123 },
+    { 0x2131, 0x2132 },
+    { 0x213c, 0x213e },
+    { 0x2141, 0x2145 },
+    { 0x214a, 0x215b },
+    { 0x2161, 0x2161 },
+    { 0x2421, 0x2421 },
+    { 0x2423, 0x2423 },
+    { 0x2425, 0x2425 },
+    { 0x2427, 0x2427 },
+    { 0x2429, 0x2429 },
+    { 0x2443, 0x2443 },
+    { 0x2463, 0x2463 },
+    { 0x2465, 0x2465 },
+    { 0x2467, 0x2467 },
+    { 0x246e, 0x246e },
+    { 0x2521, 0x2521 },
+    { 0x2523, 0x2523 },
+    { 0x2525, 0x2525 },
+    { 0x2527, 0x2527 },
+    { 0x2529, 0x2529 },
+    { 0x2543, 0x2543 },
+    { 0x2563, 0x2563 },
+    { 0x2565, 0x2565 },
+    { 0x2567, 0x2567 },
+    { 0x256e, 0x256e },
+    { 0x2575, 0x2576 },
+};
+
+Boolean is_jis_vertical(int jis)
+{
+    size_t i;
+
+    for (i=0; i<sizeof(jisv)/sizeof(*jisv); i++) {
+	if (jisv[i].low <= jis && jis <= jisv[i].hi) return True;
+    }
+    return False;
+}
+
+static FT_Library  library = NULL;
+
+static int ft_fonts_num = 0;
+static int ft_fonts_max = 0;
+static struct ft_font {
+    FT_Face face;
+    short   height;
+    short   width;
+    short   ascend;
+    int     encoding;
+    Boolean bold;
+    struct ft2vert_st *ft2vert;
+} *ft_fonts;
+
+static void ft2_init(void)
+{
+    int ft_error = FT_Init_FreeType( &library );
+    if (ft_error != 0) {
+	XDVI_WARNING(( stderr, "FreeType2: Initialization error.\n" ));
+	exit(100);
+    }
+}
+
+int ft2_open_font(struct ptexmap *map)
+{
+    int ft_error;
+    char *fontpath = get_ptex_font_pathname(map->font_filename);
+    struct ft_font *font;
+
+    if (library == NULL) ft2_init();
+    if (map->ft2_index >= 0) {  /* already opened */
+	return map->ft2_index;
+    }
+
+    if (ft_fonts_num == ft_fonts_max) {
+	if (ft_fonts_max == 0) ft_fonts_max = 8;
+	else                   ft_fonts_max *= 2;
+	ft_fonts = xrealloc(ft_fonts, sizeof(ft_fonts[0]) * ft_fonts_max);
+    }
+    font = &ft_fonts[ft_fonts_num];
+
+    memset(font, 0, sizeof(*font));
+    ft_error = FT_New_Face(library, fontpath, map->face_index, &font->face);
+    free(fontpath);
+    if (ft_error != 0) {
+	XDVI_WARNING(( stderr, "FreeType2: Open Font Error (%s).  "
+		       "Error code = %d \n", fontpath, ft_error ));
+    } else {
+	font->encoding = map->encoding;
+	if (map->encoding == ENC_JIS_V || map->encoding == ENC_UNICODE_V) {
+	    font->ft2vert = ft2vert_init(font->face);
+	}
+	font->bold = (map->variant & VAR_BOLD);
+	if (map->variant & VAR_ITALIC) map->slant = 0.3;
+	if (map->extend != 1.0 || map->slant != 0.0) {
+	    /* for debug (attention upper if condition) */
+	    /* FT_Vector vector = { 30 * (1<<6), -30 * (1<<6) }; */
+
+	    /* t1_modify_fm() in tetex-src-3.0/texk/dvipsk/writet1.c */
+	    FT_Matrix matrix;
+	    matrix.xx = (int)(map->extend * (1<<16));
+	    matrix.xy = (int)(map->extend * map->slant * (1<<16));
+	    matrix.yx = 0;
+	    matrix.yy = 1<<16;
+	    FT_Set_Transform( font->face, &matrix, 0 );
+	    /* TODO: vertical font */
+	}
+    }
+    return (map->ft2_index = ft_fonts_num++);
+}
+
+static FT_UInt glyph_index(const int char_code, struct ft_font *font)
+{
+    FT_UInt i = char_code;  /* JIS or UNICODE or GID */
+
+    if (font->encoding == ENC_JIS_H || font->encoding == ENC_JIS_V) {
+	i = jis2uni(i);
+    }
+    if (font->encoding != ENC_IDENTITY) { /* unicode -> gid */
+	i = FT_Get_Char_Index(font->face, i);
+    }
+    if ((font->encoding == ENC_JIS_V && is_jis_vertical(char_code)) ||
+	font->encoding == ENC_UNICODE_V) {
+	i = ft2vert_get_gid(font->ft2vert, i);
+    }
+    return i;
+}
+
+static void glyph_to_bitmap(struct bitmap *bm, FT_GlyphSlot g, int ascend)
+{
+    int x, xmax, xshift;
+    int y, ymax, yoffset;
+    unsigned char *src, *dst;
+
+    dst  = bm->bits;
+    src  = g->bitmap.buffer;
+    xmax = g->bitmap.pitch;
+    ymax = g->bitmap.rows;
+
+    if ( g->bitmap_left >= 0 ) {  /* to right */
+	if ( g->bitmap_left % 8 != 0 ) xmax++;
+	if ( xmax > bm->bytes_wide - g->bitmap_left/8 ) {
+	    xmax = bm->bytes_wide - g->bitmap_left/8;
+	}
+	dst   += g->bitmap_left / 8;
+	xshift = g->bitmap_left % 8;
+    } else { /* to left */
+	xmax  -=   (-g->bitmap_left) / 8;
+	src   +=   (-g->bitmap_left) / 8;
+	xshift = -((-g->bitmap_left) % 8);
+	if ( xmax > bm->bytes_wide ) xmax = bm->bytes_wide;
+    } /* We love plus % plus, we hate minus % plus. */
+    assert( xmax <= bm->bytes_wide );
+
+    yoffset = ascend - g->bitmap_top;
+    if ( yoffset >= 0 ) { /* to down */
+	dst += yoffset * bm->bytes_wide;
+	if (ymax > bm->h - yoffset) ymax = bm->h - yoffset;
+    } else { /* to up */
+	src  += (-yoffset) * g->bitmap.pitch;
+	ymax -= (-yoffset);
+	if ( ymax > bm->h ) ymax = bm->h;
+    }
+
+    if ( xmax<=0 || ymax<=0 ) return;
+    for ( y=0; y<ymax; y++ ) {
+	if ( xshift == 0 ) {
+	    for ( x=0; x<xmax; x++ ) *dst++ = *src++;
+	} else if ( xshift > 0 ) {
+	    for ( x=0; x<xmax-1; x++ ) {
+		*dst++ |= *src   >> xshift;
+		*dst   |= *src++ << (8 - xshift);
+	    }
+	    dst++; src++;
+	} else {
+	    for ( x=0; x<xmax-1; x++ ) {
+		*dst   |= *src++ << -xshift;
+		*dst++ |= *src   >> (8 + xshift);
+	    }
+	    *dst++ |= *src++ << -xshift;
+	}
+	src += g->bitmap.pitch - xmax;
+	dst += bm->bytes_wide  - xmax;
+    }
+    dst -= bm->bytes_wide - xmax;
+    /* fprintf(stderr, "dst-bm->bits=%d, ", (char*)dst-(char*)bm->bits); */
+    /* fprintf(stderr, "size=%d\n", bm->bytes_wide * bm->h); */
+    assert((char*)dst <= (char*)bm->bits + bm->bytes_wide * bm->h);
+}
+
+int ft2_get_bitmap(int char_code, int ft2_index, struct bitmap *bm)
+{
+    struct ft_font *font = &ft_fonts[ft2_index];
+    FT_Face face = font->face;
+
+    clear_bitmap(bm);
+    if (face == NULL) return 0;
+
+    if ( font->width != bm->w || font->height != bm->h ) {
+	FT_Set_Pixel_Sizes( face, bm->w, bm->h );
+	font->width  = bm->w;
+	font->height = bm->h;
+	font->ascend =
+	    bm->h * face->ascender
+	    /  (face->ascender - face->descender);
+    }
+
+    if ( FT_Load_Glyph( face, glyph_index(char_code,font), FT_LOAD_DEFAULT )
+	 != 0 ) {
+	XDVI_WARNING(( stderr, "FreeType2: Failed in load glyph. "
+		       "(char=0x%X)\n", char_code ));
+	fill_bitmap(bm);
+	return 0;
+    }
+    if ( font->bold ) FT_GlyphSlot_Embolden( face->glyph );
+    if ( FT_Render_Glyph( face->glyph, FT_RENDER_MODE_MONO ) != 0 ) {
+	XDVI_WARNING(( stderr, "FreeType2: Failed in render glyph. "
+		       "(char=0x%X)\n", char_code ));
+	fill_bitmap(bm);
+	return 0;
+    }
+    glyph_to_bitmap( bm, face->glyph, font->ascend );
+    return font->ascend;
+}
+
+#endif	/* PTEX */
diff -udNr xdvik//ft2.h pxdvik//ft2.h
--- xdvik//ft2.h	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//ft2.h	2010-07-25 14:56:37.638074508 +0900
@@ -0,0 +1,6 @@
+
+struct ptexmap;	/* forward declaration */
+struct bitmap;	/* forward declaration */
+
+int ft2_open_font(struct ptexmap *map);
+int ft2_get_bitmap(int char_code, int ft2_index, struct bitmap *bm);
diff -udNr xdvik//ft2vert.c pxdvik//ft2vert.c
--- xdvik//ft2vert.c	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//ft2vert.c	2010-07-25 14:56:37.638074508 +0900
@@ -0,0 +1,399 @@
+/*
+ * "ft2vert.c"
+ * 
+ * Converter to vertical glyph ID by handling GSUB vrt2/vert feature
+ * requires FreeType-2.1.10 or latter
+ *
+ * (C) 2005 Nobuyuki TSUCHIMURA
+ *
+ * This file is free
+ * software; you can redistribute it and/or modify it under the terms of
+ * the GNU Library General Public License as published by the Free
+ * Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.  This library is distributed in the hope
+ * that it will be useful, but WITHOUT ANY WARRANTY; without even the
+ * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ * PURPOSE.  See the GNU Library General Public License for more details.
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ * using such Lookup
+ *   ScriptTag == 'kana'
+ *   DefaultLangSys or LangSysTag == 'JAN '
+ *   FeatureTag == 'vrt2' or 'vert'
+ *
+ * [reference]
+ * http://partners.adobe.com/public/developer/opentype/index_table_formats1.html
+ * http://partners.adobe.com/public/developer/opentype/index_table_formats.html
+ * http://partners.adobe.com/public/developer/opentype/index_tag9.html#vrt2
+ */
+
+#include "xdvi-config.h"
+#include "xdvi.h"
+#ifdef	PTEX
+
+#include <ft2build.h>
+#include FT_FREETYPE_H
+#include FT_OPENTYPE_VALIDATE_H
+
+#include <stdio.h>
+#include <stdlib.h>
+#include "ft2vert.h"
+
+#define TAG_KANA FT_MAKE_TAG('k', 'a', 'n', 'a')
+#define TAG_JAN  FT_MAKE_TAG('J', 'A', 'N', ' ')
+#define TAG_VERT FT_MAKE_TAG('v', 'e', 'r', 't')
+#define TAG_VRT2 FT_MAKE_TAG('v', 'r', 't', '2')
+
+#define MALLOC(ptr, size) ptr = xmalloc(sizeof((ptr)[0]) * (size))
+#define BYTE2(p) ((p) += 2, (int)(p)[-2] << 8  | (p)[-1])
+#define BYTE4(p) ((p) += 4, (int)(p)[-4] << 24 | (int)(p)[-3] << 16 | \
+		  (int)(p)[-2] << 8 | (p)[-1])
+
+struct ft2vert_st {
+    int SubTableCount;
+    struct SubTable_st {
+	struct SingleSubst_st {
+	    FT_UInt SubstFormat;
+	    FT_UInt DeltaGlyphID; /* SubstFormat == 1 */
+	    int     GlyphCount;   /* SubstFormat == 2 */
+	    FT_UInt *Substitute;  /* SubstFormat == 2 */
+	} SingleSubst;
+	struct Coverage_st {
+	    FT_UInt CoverageFormat;
+	    int     GlyphCount;   /* CoverageFormat == 1 */
+	    FT_UInt *GlyphArray;  /* CoverageFormat == 1 */
+	    int     RangeCount;   /* CoverageFormat == 2 */
+	    struct  RangeRecord_st
+		   *RangeRecord;  /* CoverageFormat == 2 */
+	} Coverage;
+    } *SubTable;
+    FT_Bytes kanaFeature;
+    FT_Bytes vertLookup;
+    FT_Bytes vrt2Lookup;
+};
+
+struct RangeRecord_st {
+    FT_UInt Start;
+    FT_UInt End;
+};
+
+
+int isInIndex(FT_Bytes s, int index) {
+    int i, count;
+
+    if (s == NULL) return FALSE;
+    count = BYTE2(s);
+    for (i=0; i<count; i++) {
+	if (index == BYTE2(s)) return TRUE;
+    }
+    return FALSE;
+}
+
+
+/**********  Debug ***************/
+
+#ifdef DEBUG
+static FT_Bytes gsub_top;
+
+void print_offset(char *message, const FT_Bytes ptr) {
+    printf("%s offset = %x\n", message, ptr - gsub_top);
+}
+
+char *tag_to_string(FT_Tag tag) {
+    static char str[5];
+    str[0] = tag >> 24;
+    str[1] = tag >> 16;
+    str[2] = tag >> 8;
+    str[3] = tag;
+    return str;
+}
+
+void hex_dump(const FT_Bytes top) {
+    int i, j;
+    FT_Bytes s = top;
+
+    for (j=0; j<100; j++) {
+	printf("%04x : ", j*8);
+	for (i=0; i<8; i++) {
+	    printf("%02x ", s[i+j*8]);
+	}
+	printf("\n");
+    }
+}
+#endif /* DEBUG */
+
+/**********  Lookup part ***************/
+
+void scan_Coverage(struct ft2vert_st *ret, const FT_Bytes top) {
+    int i;
+    FT_Bytes s = top;
+    struct Coverage_st *t;
+
+    t = &ret->SubTable[ret->SubTableCount].Coverage;
+    t->CoverageFormat = BYTE2(s);
+    switch (t->CoverageFormat) {
+    case 1: 
+	t->GlyphCount = BYTE2(s);
+	MALLOC(t->GlyphArray, t->GlyphCount);
+	for (i=0; i<t->GlyphCount; i++) {
+	    t->GlyphArray[i] = BYTE2(s);
+	}
+	break;
+    case 2:
+	t->RangeCount = BYTE2(s);
+	MALLOC(t->RangeRecord, t->RangeCount);
+	for (i=0; i<t->RangeCount; i++) {
+	    t->RangeRecord[i].Start = BYTE2(s);
+	    t->RangeRecord[i].End   = BYTE2(s);
+	    s += 2; /* drop StartCoverageIndex */
+	}
+	break;
+    default:
+	fprintf(stderr, "scan_Coverage: unknown CoverageFormat (%d).",
+		t->CoverageFormat);
+	exit(1);
+    }
+    ret->SubTableCount++;
+}
+
+void scan_SubTable(struct ft2vert_st *ret, const FT_Bytes top) {
+    int i;
+    FT_Bytes s = top;
+    FT_Offset Coverage;
+    struct SingleSubst_st *t;
+
+    t = &ret->SubTable[ret->SubTableCount].SingleSubst;
+    t->SubstFormat = BYTE2(s);
+    Coverage       = BYTE2(s);
+    scan_Coverage(ret, top + Coverage);
+    switch (t->SubstFormat) {
+    case 1: /* SingleSubstFormat1 */
+	t->DeltaGlyphID = BYTE2(s);
+	break;
+    case 2: /* SingleSubstFormat2 */
+	t->GlyphCount   = BYTE2(s);
+	MALLOC(t->Substitute, t->GlyphCount);
+	for (i=0; i<t->GlyphCount; i++) {
+	    t->Substitute[i] = BYTE2(s);
+	}
+	break;
+    default:
+	fprintf(stderr, "scan_SubTable: unknown SubstFormat (%d).",
+		t->SubstFormat);
+	exit(1);
+    }
+}
+
+void scan_Lookup(struct ft2vert_st *ret, const FT_Bytes top) {
+    int i;
+    FT_Bytes s = top;
+    FT_UShort LookupType;
+    FT_UShort LookupFlag;
+    FT_UShort SubTableCount;
+    FT_UShort SubTable;
+
+    LookupType    = BYTE2(s);
+    LookupFlag    = BYTE2(s);
+    SubTableCount = BYTE2(s);
+    SubTable      = BYTE2(s);
+
+    MALLOC(ret->SubTable, SubTableCount);
+    for (i=0; i<SubTableCount; i++) {
+	scan_SubTable(ret, top + SubTable);
+    }
+    if (ret->SubTableCount != SubTableCount) {
+	fprintf(stderr, "warning (scan_Lookup): "
+		"SubTableCount (=%d) is not expected (=%d).\n",
+		ret->SubTableCount, SubTableCount);
+    }
+}
+
+
+void scan_LookupList(struct ft2vert_st *ret, const FT_Bytes top) {
+    int i;
+    FT_Bytes s = top;
+    int LookupCount;
+
+    LookupCount = BYTE2(s);
+
+    for (i=0; i<LookupCount; i++) {
+	FT_Bytes t = top + BYTE2(s);
+	if (isInIndex(ret->vertLookup, i)) {
+	    scan_Lookup(ret, t);
+	}
+    }
+}
+
+/********** Feature part ****************/
+
+void scan_FeatureList(struct ft2vert_st *ret, const FT_Bytes top) {
+    int i;
+    FT_Bytes s = top;
+    int FeatureCount;
+
+    FeatureCount = BYTE2(s);
+
+    for (i=0; i<FeatureCount; i++) {
+	FT_Tag FeatureTag = BYTE4(s);
+	FT_Offset Feature = BYTE2(s);
+	if (!isInIndex(ret->kanaFeature, i)) continue;
+	if (FeatureTag == TAG_VERT) {
+	    ret->vertLookup = top + Feature + 2;
+	} else if (FeatureTag == TAG_VRT2) {
+	    ret->vrt2Lookup = top + Feature + 2;
+	}
+    }
+}
+
+/********** Script part ****************/
+
+void scan_LangSys(struct ft2vert_st *ret, const FT_Bytes top) {
+    if (ret->kanaFeature == NULL) ret->kanaFeature = top + 4;
+}
+
+void scan_Script(struct ft2vert_st *ret, const FT_Bytes top) {
+    int i;
+    FT_Bytes s = top;
+    FT_Offset DefaultLangSys;
+    int LangSysCount;
+
+    DefaultLangSys = BYTE2(s);
+    if (DefaultLangSys != 0) {
+	scan_LangSys(ret, top + DefaultLangSys);
+    }
+    LangSysCount = BYTE2(s);
+
+    for (i=0; i<LangSysCount; i++) {
+	FT_Tag LangSysTag = BYTE4(s);
+	FT_Bytes t = top + BYTE2(s);
+	if (LangSysTag == TAG_JAN) {
+	    scan_LangSys(ret, t);
+	}
+    }
+}
+
+void scan_ScriptList(struct ft2vert_st *ret, const FT_Bytes top) {
+    int i;
+    FT_Bytes s = top;
+    int ScriptCount;
+
+    ScriptCount = BYTE2(s);
+
+    for (i=0; i<ScriptCount; i++) {
+	FT_Tag ScriptTag = BYTE4(s);
+	FT_Bytes t = top + BYTE2(s);
+	if (ScriptTag == TAG_KANA) {
+	    scan_Script(ret, t);
+	}
+    }
+}
+
+/********** header part *****************/
+
+void scan_GSUB_Header(struct ft2vert_st *ret, const FT_Bytes top) {
+    FT_Bytes s = top;
+    FT_Fixed  Version;
+    FT_Offset ScriptList;
+    FT_Offset FeatureList;
+    FT_Offset LookupList;
+
+#ifdef DEBUG
+    gsub_top    = top;
+#endif /* DEBUG */
+    Version     = BYTE4(s);
+    ScriptList  = BYTE2(s);
+    FeatureList = BYTE2(s);
+    LookupList  = BYTE2(s);
+
+    if (Version != 0x00010000) {
+	fprintf(stderr, "warning: GSUB Version (=%.1f) is not 1.0\n",
+		(double)Version / 0x10000);
+    }
+
+    scan_ScriptList (ret, top + ScriptList);
+    scan_FeatureList(ret, top + FeatureList);
+    /* vrt2 has higher priority over vert */
+    if (ret->vrt2Lookup != NULL) ret->vertLookup = ret->vrt2Lookup;
+    scan_LookupList (ret, top + LookupList);
+}
+
+struct ft2vert_st *ft2vert_init(FT_Face face) {
+    struct ft2vert_st *ret;
+    int ft_error;
+    FT_Bytes dummy, GSUB_table;
+
+    MALLOC(ret, 1);
+    ret->SubTableCount = 0;
+    ret->vertLookup  = NULL;
+    ret->vrt2Lookup  = NULL;
+    ret->kanaFeature = NULL;
+    ft_error =
+	FT_OpenType_Validate( face, FT_VALIDATE_GSUB,
+			      &dummy, &dummy, &dummy, &GSUB_table, &dummy);
+    if (ft_error == FT_Err_Unimplemented_Feature) {
+        fprintf(stderr, "warning: FT_OpenType_Validate is disabled. "
+                "Replace FreeType2 with otvalid-enabled version.\n");
+        return ret;
+    } else if (ft_error != 0 || GSUB_table == 0) {
+	fprintf(stderr, "warning: %s has no GSUB table.\n",
+		face->family_name);
+	return ret;
+    }
+    scan_GSUB_Header(ret, GSUB_table);
+    if (ret->SubTableCount == 0) {
+	fprintf(stderr, "warning: %s has no vrt2/vert feature.\n",
+		face->family_name);
+    }
+    free((void*)GSUB_table);
+    return ret;
+}
+
+/********** converting part *****************/
+
+static FT_UInt get_vert_nth_gid(struct SubTable_st *t, FT_UInt gid, int n) {
+    switch (t->SingleSubst.SubstFormat) {
+    case 1:
+	return gid + t->SingleSubst.DeltaGlyphID;
+    case 2:
+	return t->SingleSubst.Substitute[n];
+    }
+    fprintf(stderr, "get_vert_nth_gid: internal error");
+    exit(1);
+    return 0;
+}
+
+
+FT_UInt ft2vert_get_gid(struct ft2vert_st *ft2vert, FT_UInt gid) {
+    int i, k;
+    int j = 0; /* StartCoverageIndex */
+
+    for (k=0; k<ft2vert->SubTableCount; k++) {
+	struct SubTable_st *t = &ft2vert->SubTable[k];
+	switch (t->Coverage.CoverageFormat) {
+	case 1:
+	    for (i=0; i<t->Coverage.GlyphCount; i++) {
+		if (t->Coverage.GlyphArray[i] == gid) {
+		    return get_vert_nth_gid(t, gid, i);
+		}
+	    }
+	    break;
+	case 2:
+	    for (i=0; i<t->Coverage.RangeCount; i++) {
+		struct RangeRecord_st *r = &t->Coverage.RangeRecord[i];
+		if (r->Start <= gid && gid <= r->End) {
+		    return get_vert_nth_gid(t, gid, gid - r->Start + j);
+		}
+		j += r->End - r->Start + 1;
+	    }
+	    break;
+	default:
+	    fprintf(stderr, "ft2vert_get_gid: internal error");
+	    exit(1);
+	}
+    }
+    return gid;
+}
+
+#endif	/* PTEX */
diff -udNr xdvik//ft2vert.h pxdvik//ft2vert.h
--- xdvik//ft2vert.h	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//ft2vert.h	2010-07-25 14:56:37.638074508 +0900
@@ -0,0 +1,7 @@
+
+/* store GSUB feature vert/vrt2 */
+struct ft2vert_st *ft2vert_init(FT_Face face);
+
+/* convert horizontal glyph index to vertical glyph index
+ */
+FT_UInt ft2vert_get_gid(struct ft2vert_st *ft2vert, FT_UInt gid);
diff -udNr xdvik//gui/help-window.c pxdvik//gui/help-window.c
--- xdvik//gui/help-window.c	2009-06-29 08:47:26.000000000 +0900
+++ pxdvik//gui/help-window.c	2010-07-25 14:56:37.638074508 +0900
@@ -307,6 +307,9 @@
 #ifdef T1LIB
 	"- T1lib (direct rendering of PS fonts) enabled\n",
 #endif
+#ifdef PTEX
+	"- FreeType2 (Kanji font rendering) enabled\n",
+#endif /* PTEX */
 #if HAVE_ICONV_H
 	"- Iconv support compiled in\n",
 #if USE_LANGINFO
diff -udNr xdvik//jfm.c pxdvik//jfm.c
--- xdvik//jfm.c	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//jfm.c	2010-07-25 14:56:37.638074508 +0900
@@ -0,0 +1,94 @@
+#include "xdvi-config.h"
+#include "xdvi.h"
+#ifdef	PTEX
+
+#include "jfm.h"
+#include "util.h"
+
+#ifndef	SEEK_SET
+#define	SEEK_SET	0
+#endif
+
+/**** read_jfm0: borrowed from jxdvi-NEWS ****/
+static int read_jfm0(FILE *fp, struct jfm *j)
+{
+	int i;
+
+	fseek(fp, 0L, SEEK_SET);
+
+	/* read jfm table field. */
+	for (i = 0; i <= J_NP; i++)
+	    j->table[i] = (short) get_bytes(fp, 2);
+
+	/* read jfm header */
+	j->check_sum = get_bytes(fp, 4);
+	j->design_size = get_bytes(fp, 4);
+	fseek(fp, (long) (4 * (j->table[J_LH] - 2)), 1);
+    
+	/* read jfm char_type */
+	j->type = xmalloc(sizeof(struct jfm_char_type) * j->table[J_NT]);
+	for (i=0; i < j->table[J_NT]; i++) {
+	    j->type[i].code = (short) get_bytes(fp, 2);
+	    j->type[i].index = (short) get_bytes(fp, 2);
+	}
+    
+	/* read jfm char_info */
+	j->info = xmalloc(sizeof(struct jfm_char_info) * (j->table[J_EC] + 1));
+	for (i = 0; i <= j->table[J_EC]; i++) {
+	    j->info[i].width_ix = (unsigned char) get_byte(fp);
+	    j->info[i].height_depth_ix = (unsigned char) get_byte(fp);
+	    j->info[i].italic_ix_tag = (unsigned char) get_byte(fp);
+	    j->info[i].remainder_ix = (unsigned char) get_byte(fp);
+	}
+    
+	/* read jfm width */
+	j->width = xmalloc(sizeof(unsigned long) * j->table[J_NW]);
+	for (i = 0; i < j->table[J_NW]; i++)
+	    j->width[i] = get_bytes(fp, 4);
+
+	/* read jfm height */
+	j->height = xmalloc(sizeof(unsigned long) * j->table[J_NH]);
+	for (i = 0; i < j->table[J_NH]; i++)
+	    j->height[i] = get_bytes(fp, 4);
+
+	/* read jfm depth */
+	j->depth = xmalloc(sizeof(unsigned long) * j->table[J_ND]);
+	for (i = 0; i < j->table[J_ND]; i++)
+	    j->depth[i] = get_bytes(fp, 4);
+
+	/* read jfm italic */
+	j->italic = xmalloc(sizeof(unsigned long) * j->table[J_NI]);
+	for (i = 0; i < j->table[J_NI]; i++)
+	    j->italic[i] = get_bytes(fp, 4);
+	return 0;
+}
+
+static int jfms_max = 0;
+static int jfms_num = 0;
+static struct jfm *jfms = NULL;
+
+struct jfm *read_jfm(FILE *fp, char *fontname)
+{
+	int i;
+	struct jfm *j;
+
+	for (i=0; i<jfms_num; i++) {
+	    if (strcmp(fontname, jfms[i].fontname) == 0) return &jfms[i];
+	}
+
+	if (jfms_num == jfms_max) {
+	    if (jfms_max == 0) jfms_max = 8;
+	    else               jfms_max *= 2;
+	    jfms = xrealloc( jfms, sizeof(jfms[0]) * jfms_max );
+	}
+	j = &jfms[jfms_num];
+
+	if (read_jfm0(fp, j)) {
+	    fprintf(stderr, "Cannot open metric file: %s\n", fontname);
+	    return NULL;
+	}
+	j->fontname = xstrdup(fontname);
+	jfms_num++;
+	return j;
+}
+#endif	/* PTEX */
diff -udNr xdvik//jfm.h pxdvik//jfm.h
--- xdvik//jfm.h	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//jfm.h	2010-07-25 14:56:37.638074508 +0900
@@ -0,0 +1,47 @@
+/**********************************************
+ *  Copyright (C) Atsuo Kawaguchi, 1987.
+ *         (atsuo@sanken.osaka-u.junet)
+ *  Modified by Y. Hayashi from jxdvi-NEWS
+ *	   (hayashi@me.aoyama.ac.jp)
+ **********************************************/
+#define	J_ID 0		/* id */
+#define	J_NT 1		/* number of words in the char_type table */
+#define	J_LF 2		/* length of entire file */
+#define	J_LH 3		/* length of header */
+#define	J_BC 4		/* smallest char_type */
+#define	J_EC 5		/* largest char_type */
+#define	J_NW 6		/* number of width table */
+#define	J_NH 7		/* number of height table */
+#define	J_ND 8		/* number of depth table */
+#define	J_NI 9		/* number of italic correctiuon table */
+#define	J_NL 10		/* number of glue/kern talbe */
+#define	J_NK 11
+#define	J_NG 12
+#define	J_NP 13
+
+struct jfm_char_type {
+    unsigned short	code;		/* JIS code */
+    unsigned short	index;		/* index to char_info */
+};
+
+struct jfm_char_info {
+    unsigned char	width_ix;		/* index to width */
+    unsigned char	height_depth_ix;	/* index to height & depth */
+    unsigned char	italic_ix_tag;		/* index to italic & tag */
+    unsigned char	remainder_ix;		/* index to remainder */
+};
+
+struct jfm {
+    char	*fontname;			/* font name (min10, etc.) */
+    short	table[(J_NP+1)];		/* table */
+    unsigned long check_sum;			/* header */
+    unsigned long design_size;		
+    struct jfm_char_type *type;
+    struct jfm_char_info *info;
+    unsigned long *width;
+    unsigned long *height;
+    unsigned long *depth;
+    unsigned long *italic;
+};
+
+struct jfm *read_jfm(FILE *fp, char *fontname);
